\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : AVR-PBM.FRT
\ DESCRIPTION : Pulsbreedte modulatie op zijn AVR's
\ CATEGORY    : Voorbeeld, afmeting: 84 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, Juli 22, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR1A SFR T1-CONTROLE-A                \ Stel PBM type in
TCCR1B SFR T1-CONTROLE-B                \ Stel PBM klok bron in
OCR1AL SFR SNELHEID                     \ 0 = uit, 255 = 100 %
PORTB 3 BIT-SFR UITGANG                 \ In AVR HW vastgelegd

\ Zet maximale PBM frequentie ~ 8 KHz bij een XT van 4 MHz.
: SETUP-PBM         ( -- )
    $81 TO T1-CONTROLE-A                \ Normale 8-bit PBM
    $01 TO T1-CONTROLE-B                \ CPU klok is ingangs freq.
    1 SETDIR UITGANG                    \ OC1 (PB.3) is uitgang
    0 TO SNELHEID                       \ PBM op nul
    ;

\ Demonstratie van het gebruik

: 10MS              ( u -- )            \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: DEMO              ( -- )
    SETUP  SETUP-PBM  255 10MS          \ Start op nul, wacht even
    BEGIN
        0 FOR                           \ Doorloop alle PBM standen
            I' TO SNELHEID  10 10MS
        NEXT
    AGAIN
    ;  MAIN

                               ( Einde )
