\ Oplossing Vijgeblaadje 37 vraagstuk door: Gerard van der Sel

\ Aangepast totdat hij werkte (lengte 104 cellen), getest op STK200 bord.
\ Gerard de door jou gekozen instructie werkt alleen op de 16 hoge registers.
\ Omdat register variabelen in de 16 lage registers zitten moeten deze
\ naar een hoog regsiter gecopieerd worden. Ook zet de CPI instructie de
\ status vlaggen, daarom moet deze ook bewaard worden.
\ SNELHEID, SETUP-PBM en SNELHEID% zijn allen vereenvoudigd, vergelijk maar.

90S2313
NEEDS TARGET

\ Registers en bits in de AT90S2313  ( Opl VB37: G vd Sel)
PORTB 0 BIT-SFR UITGANG           \ Gewenste PBM uitgangsbit
TCCR0 SFR TIMER-CONTROLE          \ Timer besturing
TCNT0 SFR TIMER                   \ Timer register
TIMSK SFR TIMER-INTRPT            \ Timer interrupt activering

\ Programma declaraties
#50 CONSTANT CYCLUS               \ Max. periodeduur
CYCLUS NEGATE CONSTANT VOLGAS     \ Max. aantijd waarde
REGISTER AANTIJD                  \ Tijd dat de uitgang hoog is
REGISTER UITTIJD                  \ Tijd dat de uitgang laag is


\ Zet de timer en de uitgang goed (niet zelfstandig runnen)
CODE UITGANGOFF
  SREG R17 OUT,
  R17 POP,
  R16 POP,
  ADR TIMER ADR UITTIJD OUT,      \ Zet duur lage periode
  ADR UITGANG CBI,                \ Uitgang laag
  RETI,
END-CODE

\ Zet de timer en de uitgang goed (niet zelfstandig runnen)
CODE UITGANGON
  SREG R17 OUT,
  R17 POP,
  R16 POP,
  ADR TIMER ADR AANTIJD OUT,      \ Zet duur hoge periode
  ADR UITGANG SBI,                \ Uitgang hoog
  RETI,
END-CODE

\ Interruptroutine (niet zelfstandig runnen)
CODE PBM ( -- )
  R16 PUSH,
  R17 PUSH,
  R17 SREG IN,
  R16 ADR AANTIJD MOV,
  R16 0 CPI,
  ZER IF,                         \ 0%, uitgang uit
    ' UITGANGOFF GJMP, 
  THEN,
  R16 VOLGAS CPI,
  ZER IF,                         \ 100%, uitgang aan
    ' UITGANGON GJMP,
  THEN,
  ADR UITGANG SBIS,
  AHEAD,                          \ 1 tot 100% uitgang
    ' UITGANGOFF GJMP,
  THEN,
  ' UITGANGON GJMP,
END-CODE  T0-OVERFLOW
  
\ Zet variabelen goed voor de interruptroutine
\ PBM regelbaar tussen 0% en 100% in stappen van 2%
: SNELHEID  ( +n -- )
  CYCLUS UMIN                     \ Houdt +n tussen 0 en cyclus
  DUP NEGATE TO AANTIJD           \ Zet aan periode
  CYCLUS - TO UITTIJD ;           \ Zet uit periode

\ Stel AT90S2313 in voor interrupt van timer0
: SETUP-PBM   ( -- )
  -1 TO TIMER                     \ Dummy timer inhoud bij opstarten
  2 TO TIMER-INTRPT               \ Timer-0 interrupt aan
  2 TO TIMER-CONTROLE             \ Prescaler=8
  0 SNELHEID                      \ Zet opstart snelheid
  1 SETDIR UITGANG                \ PB.0 is uitgang
  ;

\ Geef de snelheid op in procenten (0 tot 100)
: SNELHEID% ( % -- )
  U2/ SNELHEID                    \ Converteer van % naar absoluut
  ;

\ Een echte test routine, bij het opstarten knippert de uitgang kort
\ Daarna varieert de helderheid van 100% tot nul continue.
:MAIN       ( -- )
    SETUP-PBM
    CLEAR UITGANG 250 MS
    SET UITGANG 250 MS
    INTERRUPT-ON
    BEGIN
        100 FOR
            I' SNELHEID%  50 MS
        NEXT
    AGAIN
    ;

\ Einde
